/*
 * CONFIGFLAG.CMD  by mira308sw
 *
 * WARNING!:
 *  this script work only with modified version of Builtins.out crc=19bb6041
 *  in which the function ExecuteFlasherOut can pass to called funptr till to
 *  seven integers (or addresses) parameters
 *
 * Change some configuration flag for RT4 or RT5 device with sw:8.xx
 *
 * v 1.00: 12/11/2009   first release
 */

typedef unsigned char           BYTE;
typedef unsigned short          WORD;
typedef unsigned long           DWORD;

typedef int                     BOOL;

typedef void                    DIR;
typedef void                    FILE;

typedef enum { ERROR=-1,OK=0 }  STATUS;

#define NULL                    (void*)0
#define TRUE                    1
#define FALSE                   0


STATUS  fclose                  ( FILE *f );
FILE*   fopen                   ( char *fn,char *mode );
char*   strcat                  ( char *dest,char *s );
char*   strcpy                  ( char *dest,char *src );

/* Functions and data types from MMI module
 */
#define NO                            0
#define YES                           1

STATUS  ClearScreen                   ( void );
STATUS  ShowNavigationQuestionScreen  ( char *txt, int *answ );

STATUS  ComputeCRCFile            ( char *fn,char *crc);
void    RebootSystem              ( void );
int     ExecuteFlasherOut         ( void *funptr,... );   // max 7 parameters
void*   UPGFindSymbol             ( char *sym );
STATUS  UPGCopy                   ( char* p_source, char* p_dest, int p_cut );

STATUS  UnprotectHddPartition     ( const char* p_part_name );
int     GetFileSize               ( char* file, int* size );


/* Functions and data types for RTx system
 */
// Drive letters
#define DRIVE_USB       "/bd0"
#define DRIVE_HDD       "/C"
#define DRIVE_CD        "/D"
#define DRIVE_TFFS      "/F"
#define DRIVE_NAV       "/H"
#define DRIVE_USER      "/I"
#define DRIVE_JBX       "/J"


#define CONFIGFLAG_FILE "/Data_Base/CONFIGSYSTEM/ConfigFlag.cfg"
#define CONFIGFLAG_SIZE 100

/* extra C standard function, pull out through modified Builtins.out
 */
void *pf_fread;
void *pf_fwrite;
void *pf_fseek;
void *pf_sprintf;
void *pf_unprotect;
void *pf_setflag;
void *pf_rtbi;

/* these functions work only on modified Builtins.out crc=19bb6041
 */
#define EFO                           ExecuteFlasherOut
#define FREAD( ptr,size,n,fp )        EFO( pf_fread,ptr,size,n,fp )
#define FWRITE( ptr,size,n,fp )       EFO( pf_fwrite,ptr,size,n,fp )
#define FSEEK( fp,offset,from )       EFO( pf_fseek,fp,offset,from )
#define UNPROTECTHDDPARTITION(p)      EFO( pf_unprotect,p )
#define SETDBBOOTCONFIGSYSTEMFLAG(p)  EFO( pf_setflag,p )
#define REMOVETURBOBOOTINFO()         EFO( pf_rtbi )

STATUS InitFunctionPtr ( void )
{
  int   l_iAnsw;

  pf_fread      =UPGFindSymbol( "fread" );
  pf_fwrite     =UPGFindSymbol( "fwrite" );
  pf_fseek      =UPGFindSymbol( "fseek" );
  pf_sprintf    =UPGFindSymbol( "sprintf" );
  pf_unprotect  =UPGFindSymbol( "UnprotectHddPartition__FPCc" );
  pf_setflag    =UPGFindSymbol( "InterSetDBBootConfigSystemFlag__FPCc" );
  pf_rtbi       =UPGFindSymbol( "RemoveTurboBootInfo__13C_FILE_SEARCH" );

  if( pf_fread    !=NULL &&
      pf_fwrite   !=NULL &&
      pf_fseek    !=NULL &&
      pf_sprintf  !=NULL &&
      pf_unprotect!=NULL &&
      pf_setflag  !=NULL &&
      pf_rtbi     !=NULL )
  {
      return OK;
  }
  ShowNavigationQuestionScreen( "InitFunctionPtr() FAILED!", &l_iAnsw );
  return ERROR;
}


/****************************************************************************/

/* Functions and data types for .INF file managment
 */
void    PatchCRC ( char *p_crc )
{
  if( p_crc[0]==' ' )   p_crc[0]='0';
  if( p_crc[1]==' ' )   p_crc[1]='0';
  if( p_crc[2]==' ' )   p_crc[2]='0';
  if( p_crc[3]==' ' )   p_crc[3]='0';
}

STATUS  UpdateFileInf ( char *p_sFile )
{
  FILE *l_f;
  char  l_crc[9];
  char  l_sInf[256];

  l_crc[0]=l_crc[1]=l_crc[2]=l_crc[3]=0;
  ComputeCRCFile( p_sFile,l_crc+4 );
  PatchCRC( l_crc+4 );
  l_crc[8]='\n';
  strcpy( l_sInf,p_sFile );
  strcat( l_sInf,".inf" );
  l_f=fopen( l_sInf,"r+b" );
  if( l_f==NULL )
  {
    l_f=fopen( l_sInf,"wb" );
    if( l_f==NULL )
      return ERROR;
    FWRITE( l_crc,9,1,l_f );
  }
  else
    FWRITE( l_crc,8,1,l_f );
  fclose( l_f );
  ComputeCRCFile( l_sInf,l_crc );
  PatchCRC( l_crc );
  l_f=fopen( l_sInf,"r+b" );
  if( l_f==NULL )
    return ERROR;
  FWRITE( l_crc,4,1,l_f );
  fclose( l_f );
  return OK;
}

int   ReadConfigFlag ( char *p_file,BYTE *p_flag )
{
  FILE  *l_f;
  int   l_n=0;

  if( GetFileSize( p_file,&l_n )!=OK || l_n!=CONFIGFLAG_SIZE  )
    return ERROR;

  l_f=fopen( p_file,"rb" );
  if( l_f==NULL )
    return ERROR;

  l_n=FREAD( p_flag,CONFIGFLAG_SIZE,1,l_f );
  fclose( l_f );

  if( l_n!=1 )
    return ERROR;
  return OK;
}

int   ChangeConfigFlag  ( BYTE *p_flag,char *p_name )
{
  int   l_answ;
  char  l_txt[80];

  EFO( pf_sprintf,l_txt,"%s=%d, Change to %d?",p_name,*p_flag,!*p_flag );
  ShowNavigationQuestionScreen( l_txt,&l_answ );
  if( l_answ==YES )
    *p_flag=(BYTE)!*p_flag;
  return l_answ;
}

int   WriteConfigFlag  ( char *p_file,BYTE *p_flag )
{
  int l_n;
  FILE  *l_f=fopen( p_file,"r+b" );
  if( l_f==NULL )
    return ERROR;
  FSEEK( l_f,0,0 );
  l_n=FWRITE( p_flag,CONFIGFLAG_SIZE,1,l_f );
  fclose( l_f );
  if( l_n!=1 )
    return ERROR;
  return UpdateFileInf( p_file );
}

int main ( int argc,char *argv[] )
{
  int   l_answ;
  BYTE  l_flag[CONFIGFLAG_SIZE];

  if( InitFunctionPtr()!=OK )
    return OK;

  if( ReadConfigFlag( DRIVE_HDD CONFIGFLAG_FILE,l_flag )!=OK )
    ShowNavigationQuestionScreen( "Error reading ConfigFlag.cfg",&l_answ );
  else
  {
    l_answ =ChangeConfigFlag( l_flag+0,"USB"       );
//    l_answ+=ChangeConfigFlag( l_flag+1,"UNKNOWN"   );
    l_answ+=ChangeConfigFlag( l_flag+2,"DVD"       );
    l_answ+=ChangeConfigFlag( l_flag+3,"BT"        );
    l_answ+=ChangeConfigFlag( l_flag+4,"BT_AGENDA" );

    if( l_answ==0 )
      ShowNavigationQuestionScreen( "Nothing changed",&l_answ );
    else
    {
      UNPROTECTHDDPARTITION( DRIVE_HDD );

      if( WriteConfigFlag( DRIVE_HDD CONFIGFLAG_FILE,l_flag )!=OK )
        ShowNavigationQuestionScreen( "Error upading " DRIVE_HDD,&l_answ );
      else
      {
        if( UPGCopy( DRIVE_HDD CONFIGFLAG_FILE       ,DRIVE_TFFS CONFIGFLAG_FILE       ,0 )!=OK ||
            UPGCopy( DRIVE_HDD CONFIGFLAG_FILE ".inf",DRIVE_TFFS CONFIGFLAG_FILE ".inf",0 )!=OK )
          ShowNavigationQuestionScreen( "Error upading " DRIVE_TFFS,&l_answ );
        else
        {
          if( UPGCopy( DRIVE_HDD CONFIGFLAG_FILE       ,DRIVE_HDD "/BACKUP" CONFIGFLAG_FILE       ,0 )!=OK ||
              UPGCopy( DRIVE_HDD CONFIGFLAG_FILE ".inf",DRIVE_HDD "/BACKUP" CONFIGFLAG_FILE ".inf",0 )!=OK )
            ShowNavigationQuestionScreen( "Error upading " DRIVE_HDD "/BACKUP",&l_answ );
          else
          {
            if( SETDBBOOTCONFIGSYSTEMFLAG( l_flag )!=OK )
              ShowNavigationQuestionScreen( "Error in SetDBBootConfigSystemFlag",&l_answ );
            else
            {
              REMOVETURBOBOOTINFO();

              ShowNavigationQuestionScreen( "Complete! Reboot ?",&l_answ );
              if( l_answ==YES )
                RebootSystem();
            }
          }
        }
      }
    }
  }
  ClearScreen();
  return OK;
}

