/*
 * GPH_COPY.CMD by mira308sw
 *
 * script to write GPH files from CD/USB to /C partition on RT4
 *
 * v:01.00  23/09/2009
 */

#define RTX_DRIVE     "/C"
#define CD_DRIVE      "/D"
#define USB_DRIVE     "/bd0"
#define GPH_PATH      RTX_DRIVE "/Data_Base/Graphics"

char* g_GphFile[]=
{
  "/Common/GEN_common.gph",
  "/Common/FNT_common.gph",
  "/Day/MapGfx.gph",
  "/DE/GEN_DE.gph",
  "/DU/GEN_DU.gph",
  "/EN/GEN_EN.gph",
  "/ES/GEN_ES.gph",
  "/FR/GEN_FR.gph",
  "/HARM00/$$$$_HA00.gph",
  "/HARM00/GEN_HA00.gph",
  "/HARM01/$$$$_HA00.gph",
  "/HARM01/GEN_HA01.gph",
  "/HARM02/$$$$_HA00.gph",
  "/HARM02/GEN_HA02.gph",
  "/HARM03/$$$$_HA00.gph",
  "/HARM03/GEN_HA03.gph",
  "/HARM04/$$$$_HA00.gph",
  "/HARM04/GEN_HA04.gph",
  "/HARM05/$$$$_HA00.gph",
  "/HARM05/GEN_HA05.gph",
  "/HARM06/$$$$_HA00.gph",
  "/HARM06/GEN_HA06.gph",
  "/IT/GEN_IT.gph",
  "/Night/MapGfx.gph",
  "/PO/GEN_PO.gph",
  "/SC/GEN_SC.gph",
  "/TU/GEN_TU.gph",
  "/800x446/Common/FNT_common.gph",
  "/800x446/Common/GEN_common.gph",
  "/800x446/Day/MapGfx.gph",
  "/800x446/DE/GEN_DE.gph",
  "/800x446/DU/GEN_DU.gph",
  "/800x446/EN/GEN_EN.gph",
  "/800x446/ES/GEN_ES.gph",
  "/800x446/FR/GEN_FR.gph",
  "/800x446/HARM00/$$$$_HA00.gph",
  "/800x446/HARM00/GEN_HA00.gph",
  "/800x446/HARM00/LRG_HA00.gph",
  "/800x446/HARM01/$$$$_HA00.gph",
  "/800x446/HARM01/GEN_HA01.gph",
  "/800x446/HARM01/LRG_HA01.gph",
  "/800x446/HARM02/$$$$_HA00.gph",
  "/800x446/HARM02/GEN_HA02.gph",
  "/800x446/HARM02/LRG_HA02.gph",
  "/800x446/HARM03/$$$$_HA00.gph",
  "/800x446/HARM03/GEN_HA03.gph",
  "/800x446/HARM03/LRG_HA03.gph",
  "/800x446/HARM04/$$$$_HA00.gph",
  "/800x446/HARM04/GEN_HA04.gph",
  "/800x446/HARM04/LRG_HA04.gph",
  "/800x446/HARM05/$$$$_HA00.gph",
  "/800x446/HARM05/GEN_HA05.gph",
  "/800x446/HARM05/LRG_HA05.gph",
  "/800x446/HARM06/$$$$_HA00.gph",
  "/800x446/HARM06/GEN_HA06.gph",
  "/800x446/HARM06/LRG_HA06.gph",
  "/800x446/IT/GEN_IT.gph",
  "/800x446/Night/MapGfx.gph",
  "/800x446/PO/GEN_PO.gph",
  "/800x446/SC/GEN_SC.gph",
  "/800x446/TU/GEN_TU.gph",
};

#define BUILTINS_FILE "BUILTINS.OUT"
#define TRUE          1
#define FALSE         0
#define NO            0
#define YES           1
#define OK            0
#define ERROR        -1
#define NOFILE        1
#define NULL          ((void*)0)

int     ShowNavigationQuestionScreen ( char *text,int *answer );
int     ShowNavigationBargraph       ( void );
int     StepBargraph        ( char *txt, int per );
int     ClearScreen         ( void );
int     UPGCopy             ( char *src,char *dst,int cut );
void    RebootSystem        ( void );
void*   LoadAndExecuteFile  ( char *p_root,char *p_file_name,int p_ld_symb, int p_invalid,unsigned int p_delay );
void*   UPGFindSymbol       ( char *sym );
int     ExecuteFlasherOut   ( void *pf,... );
int     GetFileSize         ( char *file,int *size );
char*   strcpy              ( char *target,char *source );
char*   strcat              ( char *target,char *source );
int     strcmp              ( char *s1,char *s2 );


int   CopyGPH ( char *p_drv,char *p_file )
{
  int   l_error;
  int   l_size;
  int   l_answ;
  char  l_src[256];
  char  l_dst[256];
  char  l_msg[256];

  strcpy( l_src,p_drv );
  strcat( l_src,p_file );
  if( GetFileSize( l_src,&l_size )==ERROR )
    return NOFILE;

  strcpy( l_msg,"Copy " );
  strcat( l_msg,p_file );
  strcat( l_msg," to RT4 ?" );
  ShowNavigationQuestionScreen( l_msg, &l_answ );
  if( l_answ==NO )
    return OK;

  ShowNavigationBargraph();
  StepBargraph( "coping...",33 );
  strcpy( l_dst,GPH_PATH  );
  strcat( l_dst,p_file );
  l_error=UPGCopy( l_src,l_dst,0 );
  if( !l_error )
  {
    StepBargraph( "coping...",75 );
    strcat( l_src,".inf" );
    strcat( l_dst,".inf" );
    l_error=UPGCopy( l_src,l_dst,0 );
  }
  ClearScreen();         
  return l_error;
}

int   UnprotectHddPartition ( char *p_drv )
{
  void *l_pf;
  int   l_answ=YES;

  l_pf=UPGFindSymbol( "UnprotectHddPartition__FPCc" );
  if( !l_pf )
    ShowNavigationQuestionScreen( "UnprotectHddPartition: symbol not found", &l_answ );
  else if( ExecuteFlasherOut( l_pf,p_drv )!=OK )
    ShowNavigationQuestionScreen( "UnprotectHddPartition: failed", &l_answ );
  else
    return OK;
  return ERROR;
}

int   RemoveTurboBootInfo ( void )
{
  void *l_pf;
  int   l_answ=YES;

  l_pf=UPGFindSymbol( "RemoveTurboBootInfo__13C_FILE_SEARCH" );
  if( !l_pf )
    ShowNavigationQuestionScreen( "RemoveTurboBootInfo: symbol not found", &l_answ );
  else if( ExecuteFlasherOut( l_pf )!=OK )
    ShowNavigationQuestionScreen( "RemoveTurboBootInfo: failed", &l_answ );
  else
    return OK;
  return ERROR;
}

int   main ( int argc,char* argv[] )
{
  int   l_answ=YES;
  int   l_i;
  int   l_nGph=sizeof( g_GphFile )/sizeof( *g_GphFile );
  int   l_bExist=FALSE;

  if( UnprotectHddPartition( RTX_DRIVE )==OK )
  {
    for( l_i=0 ; l_i<l_nGph ; l_i++ )
    {
      switch( CopyGPH( argv[1],g_GphFile[l_i] ) )
      {
      case OK:
        l_bExist=TRUE;
        break;
      case ERROR:
        return OK;
      }
    }
    if( l_bExist==FALSE && strcmp( argv[1],USB_DRIVE )!=0 )
    {
      for( l_i=0 ; l_i<l_nGph ; l_i++ )
        if( CopyGPH( USB_DRIVE,g_GphFile[l_i] )==ERROR )
          return OK;
    }
    if( RemoveTurboBootInfo()==OK )
    {
      ShowNavigationQuestionScreen( "Files copied. Reboot ?",&l_answ );
      if( l_answ==YES )
        RebootSystem();
    }
  }
  return OK;
}

